<script lang="ts" setup>
import type { BaseCopy, BaseCopyImage } from '@/types/base';

// TODO: Remove icons when the SlpIcon is fully functional
import { Group, ClipboardCheckAlt, Principles, CogUserAlt, CaseStudyAlt, Verification } from 'slippers-ui/icons';

const icons = {
  group: Group,
  'clipboard-check-alt': ClipboardCheckAlt,
  principles: Principles,
  'cog-user-alt': CogUserAlt,
  'case-study-alt': CaseStudyAlt,
  verification: Verification,
};

interface TeamOpsFeatures extends BaseCopyImage {
  items: Array<BaseCopy & { config?: { icon?: string } }>;
}

defineProps<TeamOpsFeatures>();

const dataAOS = {
  animation: 'fade-up',
  accordionAnimation: 'fade-left',
  duration: 1600,
  offset: 200,
};
</script>
<template>
  <section class="team-ops-features">
    <SlpContainer>
      <SlpTypography tag="h2" variant="heading2-bold" class="slp-mb-64">
        <div
          :data-aos="dataAOS.animation"
          :data-aos-duration="dataAOS.duration"
          :data-aos-offset="dataAOS.offset"
          v-html="$md.render(title)"
        />
      </SlpTypography>
      <SlpRow>
        <SlpColumn :cols="5">
          <div class="team-ops-features__image">
            <img
              v-if="image"
              :src="image.config.src"
              :alt="image.altText"
              :data-aos="dataAOS.animation"
              :data-aos-duration="dataAOS.duration"
              :data-aos-offset="dataAOS.offset"
              loading="lazy"
            />
          </div>
        </SlpColumn>
        <SlpColumn :cols="1" />
        <SlpColumn class="team-ops-features__accordion-wrapper">
          <div
            class="team-ops-features__items-wrapper"
            :data-aos="dataAOS.accordionAnimation"
            :data-aos-duration="dataAOS.duration"
            :data-aos-offset="dataAOS.offset"
          >
            <div
              v-for="(item, index) in items"
              :key="item.title"
              class="slp-pb-16 slp-mb-32"
              :class="{ 'team-ops-features__item-w-border': index !== items.length - 1 }"
            >
              <div class="team-ops-features__item-title">
                <div class="team-ops-features__icon">
                  <SlpIcon v-if="item.config.icon" :icon="icons[item.config.icon]" size="lg" />
                </div>
                <SlpTypography tag="h3" variant="heading5-bold">
                  {{ item.title }}
                </SlpTypography>
              </div>
              <SlpTypography variant="body2" tag="p">
                {{ item.description }}
              </SlpTypography>
            </div>
          </div>
        </SlpColumn>
      </SlpRow>
    </SlpContainer>
  </section>
</template>

<style lang="scss" scoped>
.team-ops-features {
  padding: $spacing-48 0;
  overflow: hidden;
  @media (min-width: $breakpoint-md) {
    padding: $spacing-96 0;
  }

  &__image {
    img {
      width: 100%;
    }
  }

  &__accordion {
    &:deep(.content-container) {
      @media (max-width: $breakpoint-md) {
        padding-bottom: $spacing-16;
      }
    }
  }

  &__item-title {
    display: flex;
    padding-bottom: $spacing-16;
    margin-bottom: $spacing-4;
  }

  &__item-w-border {
    border-bottom: 1px solid $color-surface-200;
  }

  &__icon {
    margin-right: $spacing-default;
  }

  &__accordion-wrapper {
    margin-top: $spacing-32;
    @media (min-width: $breakpoint-md) {
      margin-top: 0;
    }
  }
}
</style>
